<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script>
    <script
    src="https://code.jquery.com/jquery-3.5.1.js"
    integrity="sha256-QWo7LDvxbWT2tbbQ97B53yJnYU3WhH/C8ycbRAkjPDc="
    crossorigin="anonymous"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/all.min.css" integrity="sha512-+4zCK9k+qNFUR5X+cKL9EIR+ZOhtIloNl9GIKS57V1MyNsYpYcUrUeQc9vNfzsWfV28IaLL3i96P9sdNyeRssA==" crossorigin="anonymous" />
    <title>Dashboard</title>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <a class="navbar-brand" href="#">InterView SoftWare</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
          <ul class="navbar-nav">
            <!--
            <li class="nav-item active">
              <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="#">Features</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="#">Pricing</a>
            </li>
            <li class="nav-item">
              <a class="nav-link disabled" href="#" tabindex="-1" aria-disabled="true">Disabled</a>
            </li>-->
          </ul>
          <div class="ml-auto ">
            <p id="nombre" class=" text-white mb-0"></p>
            <p id="correo" class=" text-white p-0 m-0">Hola </p>
          </div>
        </div>
        
      </nav>
    <div class="container-fluid">
      <div class="row">
          <div class="col col-md-4 mt-3">
                  <div class="card card-body">
                      <form action="" method="POST" id="contactForm">
                          <h4 class="card-title">Agregar contacto</h4>
                          <div class="form-group">
                              <label for="name">Nombre</label>
                              <input type="text" id="name" name="name" class="form-control">
                          </div>
                          <div class="form-group">
                              <label for="lastName">Apellido</label>
                              <input type="text" id="lastName" name="lastName" class="form-control">
                          </div>
                          <div class="form-group">
                              <label for="phone">Telefono</label>
                              <input type="text" id="phone" name="phone" class="form-control">
                          </div>
                          <div class="form-group">
                              <label for="email">Email </label>
                              <input type="email" id="email" name="Email" class="form-control">
                          </div>
                          <div class="form-group">
                              <label for="address">Dirección </label>
                              <input type="text" id="address" name="address" class="form-control">
                          </div>
                          <button type="submit"  class="btn-block btn btn-danger">Agregar</button>
                      </form>
                      <form action="" method="PUT" id="updateForm" style="display: none;">
                          <h4 class="card-title">Actualizar contacto</h4>
                          <div class="form-group">
                              <label for="name">Nombre</label>
                              <input type="text" id="updateName" name="name" class="form-control">
                          </div>
                          <div class="form-group">
                              <label for="lastName">Apellido</label>
                              <input type="text" id="updateLastName" name="lastName" class="form-control">
                          </div>
                          <div class="form-group">
                              <label for="phone">Telefono</label>
                              <input type="text" id="updatePhone" name="phone" class="form-control">
                          </div>
                          <div class="form-group">
                              <label for="email">Email </label>
                              <input type="email" id="updateEmail" name="Email" class="form-control">
                          </div>
                          <div class="form-group">
                              <label for="address">Dirección </label>
                              <input type="text" id="updateAddress" name="address" class="form-control">
                          </div>
                          <div>
                              <button type="button" onclick="viewUpdate()" class="btn btn-danger">Cancelar</button>
                              <button type="submit"  class=" btn btn-primary">Actualizar</button>

                          </div>
                      </form>
                  </div>
          </div>
        <div class="col col-md-8 mt-3 ">
            <table class="table ">
                <thead class="thead-dark">
                <tr>
                    <th scope="col">Nombre</th>
                    <th scope="col">Apellido</th>
                    <th scope="col">Telefono</th>
                    <th scope="col">Email</th>
                    <th scope="col">Dirección</th>
                    <th scope="col"></th>
                </tr>
                </thead>
                <tbody id="tableFill">

                </tbody>

            </table>
            <div class="text-center">
                <nav aria-label="Page navigation example"  class="d-flex justify-content-center">
                    <ul class="pagination " id="pagination" >

                    </ul>
                </nav>
                <p class="pt-0 d-block">Total elements: <span style="color: darkcyan" id="totalElements"></span></p>
            </div>
        </div>

      </div>
    </div>

    <script>
        let visibility = true;
      let idUser;
      let page;
      let totalPages;
      let totalElements;
      let contactos;
      let token;
        $(document).ready(()=> {
            token = localStorage.getItem('token')
            if(!token){
                $(location).attr('href', 'http://localhost:4000/login')
            }
            $.ajax({
                url: 'http://localhost:4000/verify-jwt',
                method: 'POST',
                headers: {
                    'Authorization': token
                },
                success: () => {renderContacts(token, 1)},
                statusCode: {
                    400: ()=> {
                        $(location).attr('href', 'http://localhost:4000/login')
                    }
                }
            })
            var user = JSON.parse(atob(token.split('.')[1]));
            $("#nombre").text(user.name)
            $("#correo").text(user.email)
            idUser = user.id

        })

        function renderContacts(token, pageN){
            $.ajax({
                url: `http://localhost:4000/api/contact/searchAllByUser?id=${idUser}&page=${page}`,
                method: 'GET',
                headers: {
                  'Authorization': token
                },
                success: (data) => {
                    $("#tableFill").empty()
                    $("#pagination").empty()
                    contactos = []
                    contactos = data.docs;
                    totalPages = data.totalPages;
                    totalElements = data.totalDocs;
                    if (pageN !== 0) page = pageN;
                    contactos.forEach(contact  => {
                        $("#tableFill")
                            .append(` <tr>
                                    <th >${contact.name}</th>
                                    <td>${contact.lastName}</td>
                                    <td>${contact.phone}</td>
                                    <td>${contact.email}</td>
                                    <td>${contact.address}</td>
                                    <td><i id="viewUpdate" onclick="viewUpdate()" style="color: red" class="fas fa-eye mr-3"></i>
                                    <i class="fas fa-trash-alt" onclick="deleteContact()"></i></td>
                                </tr>`)
                    })
                    $("#totalElements").text(totalElements)
                    for (let i =0; i < totalPages; i++){
                        $("#pagination").append(`<li class="page-item" onclick="changePage(${i+1})"><a class="page-link" >${i+1}</a></li>`)
                    }
                }

              })
        }
        $("#contactForm").on('submit', (event)=> {
            event.preventDefault()
            let name = $("#name").val()
            let lastName = $("#lastName").val()
            let phone = $("#phone").val()
            let email = $("#email").val()
            let address = $("#address").val()
            let data = {
                name, lastName, phone, email, address,
                user: idUser
            }
            let  token = localStorage.getItem('token')
            console.log(data)
            $.ajax({
                url: 'http://localhost:4000/api/contact/create',
                method: 'POST',
                headers: {
                    'Authorization': token
                },
                data: data,
                success: ()=> {
                    renderContacts(token, 1)
                    $("#contactForm")[0].reset()
                }
            })
        })
      function changePage(page){
            renderContacts(token, page)
      }

      function viewUpdate(data){
            if (visibility){
                $("#contactForm").hide()
                $("#updateForm").css('display', 'inline')
                console.log(data)
                visibility = false;
            }else {
                $("#contactForm").show()
                $("#updateForm").css('display', 'none')
                visibility = true;
            }
      }
      function deleteContact(numero){
            console.log(numero)
      }

    </script>
</body>
</html>
